#if 0
Fixed point operator.
#endif

#define FIX (1 << 14)

#define CVT_FP(x) ((int64_t)((x) * FIX))
#define XTOI_RNDZ(x) ((x) / FIX)
#define XTOI_RNDN(x) (((x) < 0)?(((x) - FIX / 2) / FIX):((x) + FIX / 2) /FIX)
#define P_XY(x, y) ((x) + (y))
#define M_XY(x, y) ((x) - (y))
#define P_XN(x, n) ((x) + CVT_FP((n)))
#define M_XN(x, n) ((x) - CVT_FP((n)))

#define MULT_XY(x, y) \
({\
  int64_t __x = (x); \
		int64_t __y = (y); \
		int64_t __result = 0; \
\
		if ((__x >= 0 && __y >= 0) || (__x < 0 && __y < 0)) \
			 { \
				  __result = __x * __y + FIX / 2;\
						__result /= FIX;\
				} \
		else \
		  { \
				  __result = __x * __y - FIX / 2; \
						__result /= FIX;\
				} \
		__result; \
})

#define MULT_XN(x, n) MULT_XY ((x), CVT_FP (n))

#define DIV_XY(x, y) \
({ \
  int64_t __x = (x); \
		int64_t __y = (y); \
		int64_t __result = 0; \
\
		__result = __x * FIX / __y; \
		__result; \
})

#define DIV_XN(x, n) DIV_XY ((x), CVT_FP (n))

