#include "userprog/syscall.h"
#include <stdio.h>
#include <syscall-nr.h>
#include "threads/interrupt.h"
#include "threads/thread.h"
// YOO : 이거 웬지 필요한 삘이 ... (-ㅅ-);
#include "userprog/process.h"
#include "threads/init.h"
#include "filesys/filesys.h"
#include "filesys/file.h"
#include "devices/input.h"
#include "lib/string.h"
#include "userprog/pagedir.h"

static void syscall_handler (struct intr_frame *);
//YOO : system call용..
void sys_exit (uint32_t **esp);
tid_t sys_exec (uint32_t **esp);
int sys_wait (uint32_t **esp);

bool sys_create (uint32_t **esp);
bool sys_remove (uint32_t **esp);
//int sys_open (uint32_t **esp);
int sys_filesize (uint32_t **esp);
//int sys_read (uint32_t **esp);

int sys_write (uint32_t **esp);
void sys_close (uint32_t **esp);


void
syscall_init (void) 
{
  intr_register_int (0x30, 3, INTR_ON, syscall_handler, "syscall");
}

static void
syscall_handler (struct intr_frame *f UNUSED) 
{
	//int syscall_no = *(int *) (f->esp);
	// YOO : 귀찮아서 참조용.
	uint32_t *esp = f->esp;
	int syscall_no = *esp++;

	//printf("Syscall number : %d\n ", syscall_no);
	// YOO : 여기에 호출할 syscall을 연결
	switch (syscall_no)
	{
		case SYS_HALT:                   /* Halt the operating system. */
			//asm volatile ("hlt");
			power_off();
			break;
		case SYS_EXIT:                   /* Terminate this process. */
			sys_exit (&esp);
			break;
    case SYS_EXEC:                   /* Start another process. */
			f->eax = sys_exec (&esp);
			break;
    case SYS_WAIT:                   /* Wait for a child process to die. */
			f->eax = sys_wait (&esp);
    	break;
    case SYS_CREATE:                 /* Create a file. */
			//f->eax = sys_create (&esp);
  	  break;
    case SYS_REMOVE:                 /* Delete a file. */
			f->eax = sys_remove (&esp);
	    break;
	  case SYS_OPEN:                   /* Open a file. */
			break;
	  case SYS_FILESIZE:               /* Obtain a file's size. */
			f->eax = sys_filesize (&esp);
	  	break;
	  case SYS_READ:                   /* Read from a file. */
		  break;
	  case SYS_WRITE:                  /* Write to a file. */
			f->eax = sys_write (&esp);
		  break;
	  case SYS_SEEK:                   /* Change position in a file. */
	  	break;
	  case SYS_TELL:                   /* Report current position in a file. */
			break;
		case SYS_CLOSE:                  /* Close a file. */
			break;
		default:
		// YOO : system call이 없...?
		NOT_REACHED ();
		//thread_exit ();
		break;
	}
 // printf ("system call!\n");
 // thread_exit ();
}

void 
sys_exit (uint32_t **esp)
{
	int status = (int)*(*esp)++;
	// YOO : TEST...for print process name
	struct thread *cur = thread_current ();
	char *save_ptr;
	char *p_name = strtok_r (cur->name, " ", &save_ptr);
	// YOO : TERMINATED MESSAGE;
	printf ("%s: exit(%d)\n", p_name, status);

	//wake up waiting parent...
	process_awake_waiter (status);
	thread_exit ();
}

tid_t
sys_exec (uint32_t **esp)
{
	char *cmdline = (char *) *(*esp)++;
	tid_t tid = process_execute (cmdline);
	return tid;
}

int 
sys_wait (uint32_t **esp)
{
	tid_t tid = (tid_t) *(*esp)++;
	
	int status = process_wait (tid);
	return status;
}

bool
sys_create (uint32_t **esp)
{
	char *p_name = (char *) *(*esp)++;
	uint32_t size = (uint32_t) *(*esp)++;

	return filesys_create (p_name, size);
}

bool 
sys_remove (uint32_t **esp)
{
	char *file = (char *) *(*esp)++;
	return filesys_remove (file);
}

int
sys_filesize (uint32_t **esp)
{
	int fd = (int) *(*esp)++;
	struct thread *t = thread_current ();
	
	if (t->fd_table[fd] == NULL) return -1;
	else return (file_length(t->fd_table[fd]));
}

int
sys_write (uint32_t **esp)
{
	int fd = (int) *(*esp)++;
	char *buffer = (char*) *(*esp)++;
	uint32_t size = (uint32_t)* (*esp)++;

	//write stdout
	if (fd == 1)
	{
		putbuf (buffer, size);
		return size;
	}
	else
	{
		//YOO : FILE 에는????
		return -1;
	}
}

